﻿Shader "custom/rhy_02"
{
    Properties
    {
		_AddW("Add white", Color)= (0,0,0,0)
		_AddRGB ("Add light", Range(-1,5)) = 0.9
		_Outline("Outline", Range(0,0.02)) = 0.01
		_OutColor("OutlineColor", Color)= (0,0,0,0)
		_MainTex ("Albedo (RGB)", 2D) = "white" {}
		_BumpMap ("NormalMap", 2D) = "bump"{}
		_SpecCol("Specular Color", Color) = (1,0.961,0.853,1)
		_SpecPow("Specular Power", Range(0,100)) = 60.2
		
		_ShadowPower("ShadowPower",Range(-1,1)) = -0.3
		_LightAdd("LightAdd",Range(-10,10)) = 1
		_push("push",Range(-10,10)) = 0.2


	}
		SubShader
		{
			Tags { "RenderType" = "Opaque" }

			cull front//1st pass		
			CGPROGRAM
			#pragma surface surf Nolight vertex:vert noambient

			float4 _AddW;
			float _Outline;
			float4 _OutColor;
			float _AddRGB;

			void vert(inout appdata_full v) {
			v.vertex.xyz = v.vertex.xyz + v.normal.xyz*_Outline;
		}

		struct Input {
			float4 color:COLOR;
		};

		void surf(Input IN, inout SurfaceOutput o) {


		}
		float4 LightingNolight(SurfaceOutput s, float3 lightDir, float atten) {
			

			//return float4(_OutColor);
			return float4(_OutColor + _AddW);
		}

		ENDCG

			cull back //2nd pass

			CGPROGRAM

#pragma surface surf Test 

		float4 _AddW;
		float _AddRGB;
		sampler2D _MainTex;
		sampler2D _BumpMap;
		sampler2D _GlossTex;
		float4 _SpecCol;
		float _SpecPow;
		float _ShadowPower;
		float _LightAdd;
		float _push;


		struct Input
		{
			float2 uv_MainTex;
			float2 uv_BumpMap;
			float2 uv_GlossTex;


			//float3 viewDir; // 버텍스가 카메라 방향을 보는 방향
		};


		void surf(Input IN, inout SurfaceOutput o)
		{
			fixed4 c = tex2D(_MainTex, IN.uv_MainTex);
			float4 m = tex2D(_GlossTex, IN.uv_GlossTex);
			o.Albedo = c.rgb;
			o.Normal = UnpackNormal(tex2D(_BumpMap, IN.uv_BumpMap));
			o.Gloss = m.a;
			o.Alpha = c.a;

		}


		float4 LightingTest(SurfaceOutput s, float3 lightDir, float3 viewDir, float atten)
		{
			float4 final;

			float3 DiffColor;
			float ndotl = (saturate(dot(s.Normal, lightDir) + _push) + _ShadowPower) + _LightAdd;
			DiffColor = ndotl * s.Albedo * _LightColor0.rgb *atten*_AddRGB;



			float3 SpecColor;
			float3 H = normalize(lightDir + viewDir);
			float spec = saturate(dot(H, s.Normal));
			spec = pow(spec, _SpecPow);
			SpecColor = spec * _SpecCol.rgb*s.Gloss;

			final.rgb = DiffColor.rgb + SpecColor.rgb + _AddW;
			//final.rgb = DiffColor.rgb + SpecColor.rgb;
			final.a = s.Alpha;
			return final;
		}

        ENDCG
    }
    FallBack "Diffuse"
}
